<script>
import axios from "axios";

export default {
  data() {
    return {
      buku: {
        title: "",
        author: "",
        synopsis: "",
        genre_id: -1,
        price: "",
        cover: null,
        genres: [],
        errorMessage: '',
        successMessage: ''
      },
      genres: [], // Array untuk menyimpan data genre dari backend
    };
  },
  mounted() {
  this.fetchGenres();
},
methods: {
  fetchGenres() {
    axios.get('http://localhost:8000/api/genre')
      .then(response => {
        this.genres = response.data;
        // Tetapkan nilai default untuk buku.genre_id setelah data genre selesai dimuat
        this.buku.genre_id = this.genres.length > 0 ? this.genres[0].id : null;
      })
      .catch(error => {
        console.error('Error fetching genres:', error);
      });
  },
    tambahBuku() {
      const formData = new FormData();
      formData.append("title", this.buku.title);
      formData.append("author", this.buku.author);
      formData.append("synopsis", this.buku.synopsis);
      formData.append("genre_id", this.buku.genre_id);
      formData.append("price", this.buku.price);
      formData.append("cover", this.buku.cover);

      axios
        .post("http://localhost:8000/api/tambah-buku", formData, {
          headers: {
            "Content-Type": "multipart/form-data",
          },
        })
        .then((response) => {
          console.log("Buku berhasil ditambahkan:", response.data);
          this.successMessage = 'Buku berhasil ditambahkan';
          // Reset form
          this.buku = {
            title: "",
            author: "",
            synopsis: "",
            genre_id: "",
            price: "",
            cover: "",
            
          };
        })
        .catch((error) => {
          console.error("Gagal menambahkan buku:", error);
          this.errorMessage = 'Buku gagal ditambahkan';
        });
    },
    onFileChange(event) {
      this.buku.cover = event.target.files[0];
    },
  },
};
</script>
<template>
  <div class="container vh-100 pt-5">
    <div class="col-lg-8 mx-auto mt-3">
      <h1 class="text-center">Tambah Buku</h1>
      <!-- Tampilkan pesan kesalahan jika terjadi error -->
      <div v-if="errorMessage" class="alert alert-danger mt-3">
        {{ errorMessage }}
      </div>
      <!-- Tampilkan pesan sukses jika berhasil menambahkan buku -->
      <div v-if="successMessage" class="alert alert-success mt-3">
        {{ successMessage }}
      </div>
      <form @submit.prevent="tambahBuku">
        <div class="my-3">
          <label for="title">Judul</label>
          <input
            type="text"
            class="form-control"
            id="title"
            v-model="buku.title"
            required
          />
        </div>
        <div class="my-3">
          <label for="author">Penulis</label>
          <input
            type="text"
            class="form-control"
            id="author"
            v-model="buku.author"
            required
          />
        </div>
        <div class="my-3">
          <label for="synopsis">Sinopsis</label>
          <textarea
            class="form-control"
            id="synopsis"
            v-model="buku.synopsis"
            required
          ></textarea>
        </div>
        <div class="my-3">
          <label for="genre_id">Genre</label>
          <select
            class="form-control"
            id="genre_id"
            v-model="buku.genre_id"
            required
          >
            <option value="">Pilih Genre</option>
            <option v-for="genre in genres" :key="genre.genre_id" :value="genre.genre_id">{{ genre.genre }}</option>
          </select>
        </div>
        <div class="my-3">
          <label for="price">Harga</label>
          <input
            type="number"
            class="form-control"
            id="price"
            v-model="buku.price"
            required
          />
        </div>
        <div class="my-3">
          <label for="cover">Cover</label>
          <input
            type="file"
            class="form-control"
            id="cover"
            @change="onFileChange"
            required
          />
        </div>
        <button type="submit" class="btn btn-primary">Tambah Buku</button>
      </form>
    </div>
  </div>
</template>
